Index: drivers/filesystems/btrfs/read.c
===================================================================
--- drivers/filesystems/btrfs/read.c	(révision 75772)
+++ drivers/filesystems/btrfs/read.c	(copie de travail)
@@ -2316,227 +1033,497 @@
         }
 #ifdef DEBUG_STATS
         time2 = KeQueryPerformanceCounter(NULL);
-        
+
         Vcb->stats.read_csum_time += time2.QuadPart - time1.QuadPart;
 #endif
-    }
-    
-    if (checksum_error) {
-        CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&ci[1];
-        
-        for (i = 0; i < needs_reconstruct; i++) {
-            PIO_STACK_LOCATION IrpSp;
-            UINT16 reconstruct_stripe = i == 0 ? missing1 : missing2;
-            
-            // re-run Irps that we cancelled
-            
-            if (context->stripes[reconstruct_stripe].Irp) {
-                if (devices[reconstruct_stripe]->devobj->Flags & DO_DIRECT_IO) {
-                    MmUnlockPages(context->stripes[reconstruct_stripe].Irp->MdlAddress);
-                    IoFreeMdl(context->stripes[reconstruct_stripe].Irp->MdlAddress);
+    } else if (degraded)
+        checksum_error = TRUE;
+
+    if (!checksum_error)
+        return STATUS_SUCCESS;
+
+    if (context->tree) {
+        UINT8* sector;
+        UINT16 k, physstripe, parity1, parity2, error_stripe;
+        UINT64 off;
+        BOOL recovered = FALSE, failed = FALSE;
+        ULONG num_errors = 0;
+
+        sector = ExAllocatePoolWithTag(NonPagedPool, Vcb->superblock.node_size * (ci->num_stripes + 2), ALLOC_TAG);
+        if (!sector) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+
+        get_raid0_offset(addr - offset, ci->stripe_length, ci->num_stripes - 2, &off, &stripe);
+
+        parity1 = (((addr - offset) / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
+        parity2 = (parity1 + 1) % ci->num_stripes;
+
+        physstripe = (parity2 + stripe + 1) % ci->num_stripes;
+
+        j = (parity2 + 1) % ci->num_stripes;
+
+        for (k = 0; k < ci->num_stripes - 1; k++) {
+            if (j != physstripe) {
+                if (devices[j] && devices[j]->devobj) {
+                    Status = sync_read_phys(devices[j]->devobj, cis[j].offset + off, Vcb->superblock.node_size, sector + (k * Vcb->superblock.node_size), FALSE);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("sync_read_phys returned %08x\n", Status);
+                        log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_READ_ERRORS);
+                        num_errors++;
+                        error_stripe = k;
+
+                        if (num_errors > 1) {
+                            failed = TRUE;
+                            break;
+                        }
+                    }
+                } else {
+                    num_errors++;
+                    error_stripe = k;
+
+                    if (num_errors > 1) {
+                        failed = TRUE;
+                        break;
+                    }
                 }
-                IoFreeIrp(context->stripes[reconstruct_stripe].Irp);
             }
-            
-            if (!Irp) {
-                context->stripes[reconstruct_stripe].Irp = IoAllocateIrp(devices[reconstruct_stripe]->devobj->StackSize, FALSE);
-                
-                if (!context->stripes[reconstruct_stripe].Irp) {
-                    ERR("IoAllocateIrp failed\n");
-                    return STATUS_INSUFFICIENT_RESOURCES;
+
+            j = (j + 1) % ci->num_stripes;
+        }
+
+        if (!failed) {
+            if (num_errors == 0) {
+                tree_header* th = (tree_header*)(sector + (stripe * Vcb->superblock.node_size));
+                UINT32 crc32;
+
+                RtlCopyMemory(sector + (stripe * Vcb->superblock.node_size), sector + ((ci->num_stripes - 2) * Vcb->superblock.node_size),
+                              Vcb->superblock.node_size);
+
+                for (j = 0; j < ci->num_stripes - 2; j++) {
+                    if (j != stripe)
+                        do_xor(sector + (stripe * Vcb->superblock.node_size), sector + (j * Vcb->superblock.node_size), Vcb->superblock.node_size);
                 }
-            } else {
-                context->stripes[reconstruct_stripe].Irp = IoMakeAssociatedIrp(Irp, devices[reconstruct_stripe]->devobj->StackSize);
-                
-                if (!context->stripes[reconstruct_stripe].Irp) {
-                    ERR("IoMakeAssociatedIrp failed\n");
-                    return STATUS_INSUFFICIENT_RESOURCES;
+
+                crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, Vcb->superblock.node_size - sizeof(th->csum));
+
+                if (th->address == addr && crc32 == *((UINT32*)th->csum) && (generation == 0 || th->generation == generation)) {
+                    RtlCopyMemory(buf, sector + (stripe * Vcb->superblock.node_size), Vcb->superblock.node_size);
+
+                    if (devices[physstripe] && devices[physstripe]->devobj)
+                        ERR("recovering from checksum error at %llx, device %llx\n", addr, devices[physstripe]->devitem.dev_id);
+
+                    recovered = TRUE;
+
+                    if (!Vcb->readonly && devices[physstripe] && devices[physstripe]->devobj && !devices[physstripe]->readonly) { // write good data over bad
+                        Status = write_data_phys(devices[physstripe]->devobj, cis[physstripe].offset + off,
+                                                 sector + (stripe * Vcb->superblock.node_size), Vcb->superblock.node_size);
+                        if (!NT_SUCCESS(Status)) {
+                            WARN("write_data_phys returned %08x\n", Status);
+                            log_device_error(Vcb, devices[physstripe], BTRFS_DEV_STAT_WRITE_ERRORS);
+                        }
+                    }
                 }
             }
-            
-            IrpSp = IoGetNextIrpStackLocation(context->stripes[reconstruct_stripe].Irp);
-            IrpSp->MajorFunction = IRP_MJ_READ;
-            
-            if (devices[reconstruct_stripe]->devobj->Flags & DO_BUFFERED_IO) {
-                FIXME("FIXME - buffered IO\n");
-            } else if (devices[reconstruct_stripe]->devobj->Flags & DO_DIRECT_IO) {
-                context->stripes[reconstruct_stripe].Irp->MdlAddress = IoAllocateMdl(context->stripes[reconstruct_stripe].buf,
-                                                                                        stripeend[reconstruct_stripe] - stripestart[reconstruct_stripe], FALSE, FALSE, NULL);
-                if (!context->stripes[reconstruct_stripe].Irp->MdlAddress) {
-                    ERR("IoAllocateMdl failed\n");
-                    return STATUS_INSUFFICIENT_RESOURCES;
+
+            if (!recovered) {
+                UINT32 crc32;
+                tree_header* th = (tree_header*)(sector + (ci->num_stripes * Vcb->superblock.node_size));
+                BOOL read_q = FALSE;
+
+                if (devices[parity2] && devices[parity2]->devobj) {
+                    Status = sync_read_phys(devices[parity2]->devobj, cis[parity2].offset + off,
+                                            Vcb->superblock.node_size, sector + ((ci->num_stripes - 1) * Vcb->superblock.node_size), FALSE);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("sync_read_phys returned %08x\n", Status);
+                        log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_READ_ERRORS);
+                    } else
+                        read_q = TRUE;
                 }
-                
-                MmProbeAndLockPages(context->stripes[reconstruct_stripe].Irp->MdlAddress, KernelMode, IoWriteAccess);
-            } else {
-                context->stripes[reconstruct_stripe].Irp->UserBuffer = context->stripes[reconstruct_stripe].buf;
+
+                if (read_q) {
+                    if (num_errors == 1) {
+                        raid6_recover2(sector, ci->num_stripes, Vcb->superblock.node_size, stripe, error_stripe, sector + (ci->num_stripes * Vcb->superblock.node_size));
+
+                        crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, Vcb->superblock.node_size - sizeof(th->csum));
+
+                        if (th->address == addr && crc32 == *((UINT32*)th->csum) && (generation == 0 || th->generation == generation))
+                            recovered = TRUE;
+                    } else {
+                        for (j = 0; j < ci->num_stripes - 1; j++) {
+                            if (j != stripe) {
+                                raid6_recover2(sector, ci->num_stripes, Vcb->superblock.node_size, stripe, j, sector + (ci->num_stripes * Vcb->superblock.node_size));
+
+                                crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, Vcb->superblock.node_size - sizeof(th->csum));
+
+                                if (th->address == addr && crc32 == *((UINT32*)th->csum) && (generation == 0 || th->generation == generation)) {
+                                    recovered = TRUE;
+                                    error_stripe = j;
+                                    break;
+                                }
+                            }
+                        }
+                    }
+                }
+
+                if (recovered) {
+                    UINT16 error_stripe_phys = (parity2 + error_stripe + 1) % ci->num_stripes;
+
+                    if (devices[physstripe] && devices[physstripe]->devobj)
+                        ERR("recovering from checksum error at %llx, device %llx\n", addr, devices[physstripe]->devitem.dev_id);
+
+                    RtlCopyMemory(buf, sector + (ci->num_stripes * Vcb->superblock.node_size), Vcb->superblock.node_size);
+
+                    if (!Vcb->readonly && devices[physstripe] && devices[physstripe]->devobj && !devices[physstripe]->readonly) { // write good data over bad
+                        Status = write_data_phys(devices[physstripe]->devobj, cis[physstripe].offset + off,
+                                                 sector + (ci->num_stripes * Vcb->superblock.node_size), Vcb->superblock.node_size);
+                        if (!NT_SUCCESS(Status)) {
+                            WARN("write_data_phys returned %08x\n", Status);
+                            log_device_error(Vcb, devices[physstripe], BTRFS_DEV_STAT_WRITE_ERRORS);
+                        }
+                    }
+
+                    if (devices[error_stripe_phys] && devices[error_stripe_phys]->devobj) {
+                        if (error_stripe == ci->num_stripes - 2) {
+                            ERR("recovering from parity error at %llx, device %llx\n", addr, devices[error_stripe_phys]->devitem.dev_id);
+
+                            log_device_error(Vcb, devices[error_stripe_phys], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+
+                            RtlZeroMemory(sector + ((ci->num_stripes - 2) * Vcb->superblock.node_size), Vcb->superblock.node_size);
+
+                            for (j = 0; j < ci->num_stripes - 2; j++) {
+                                if (j == stripe) {
+                                    do_xor(sector + ((ci->num_stripes - 2) * Vcb->superblock.node_size), sector + (ci->num_stripes * Vcb->superblock.node_size),
+                                           Vcb->superblock.node_size);
+                                } else {
+                                    do_xor(sector + ((ci->num_stripes - 2) * Vcb->superblock.node_size), sector + (j * Vcb->superblock.node_size),
+                                            Vcb->superblock.node_size);
+                                }
+                            }
+                        } else {
+                            ERR("recovering from checksum error at %llx, device %llx\n", addr + ((error_stripe - stripe) * ci->stripe_length),
+                                devices[error_stripe_phys]->devitem.dev_id);
+
+                            log_device_error(Vcb, devices[error_stripe_phys], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+
+                            RtlCopyMemory(sector + (error_stripe * Vcb->superblock.node_size),
+                                          sector + ((ci->num_stripes + 1) * Vcb->superblock.node_size), Vcb->superblock.node_size);
+                        }
+                    }
+
+                    if (!Vcb->readonly && devices[error_stripe_phys] && devices[error_stripe_phys]->devobj && !devices[error_stripe_phys]->readonly) { // write good data over bad
+                        Status = write_data_phys(devices[error_stripe_phys]->devobj, cis[error_stripe_phys].offset + off,
+                                                 sector + (error_stripe * Vcb->superblock.node_size), Vcb->superblock.node_size);
+                        if (!NT_SUCCESS(Status)) {
+                            WARN("write_data_phys returned %08x\n", Status);
+                            log_device_error(Vcb, devices[error_stripe_phys], BTRFS_DEV_STAT_WRITE_ERRORS);
+                        }
+                    }
+                }
             }
+        }
 
-            IrpSp->Parameters.Read.Length = stripeend[reconstruct_stripe] - stripestart[reconstruct_stripe];
-            IrpSp->Parameters.Read.ByteOffset.QuadPart = stripestart[reconstruct_stripe] + cis[reconstruct_stripe].offset;
-            
-            context->stripes[reconstruct_stripe].Irp->UserIosb = &context->stripes[reconstruct_stripe].iosb;
-            
-            IoSetCompletionRoutine(context->stripes[reconstruct_stripe].Irp, read_data_completion, &context->stripes[reconstruct_stripe], TRUE, TRUE, TRUE);
+        if (!recovered) {
+            ERR("unrecoverable checksum error at %llx\n", addr);
+            ExFreePool(sector);
+            return STATUS_CRC_ERROR;
+        }
 
-            context->stripes[reconstruct_stripe].status = ReadDataStatus_Pending;
+        ExFreePool(sector);
+    } else {
+        ULONG sectors = length / Vcb->superblock.sector_size;
+        UINT8* sector;
+
+        sector = ExAllocatePoolWithTag(NonPagedPool, Vcb->superblock.sector_size * (ci->num_stripes + 2), ALLOC_TAG);
+        if (!sector) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
         }
-            
-        if (needs_reconstruct > 0) {
-#ifdef DEBUG_STATS
-            LARGE_INTEGER time1, time2;
-#endif
-            context->stripes_left = needs_reconstruct;
-            KeClearEvent(&context->Event);
-            
-#ifdef DEBUG_STATS
-            if (!context->tree)
-                time1 = KeQueryPerformanceCounter(NULL);
-#endif
-            
-            for (i = 0; i < needs_reconstruct; i++) {
-                UINT16 reconstruct_stripe = i == 0 ? missing1 : missing2;
-                
-                IoCallDriver(devices[reconstruct_stripe]->devobj, context->stripes[reconstruct_stripe].Irp);
-            }
-            
-            KeWaitForSingleObject(&context->Event, Executive, KernelMode, FALSE, NULL);
-            
-#ifdef DEBUG_STATS
-            if (!context->tree) {
-                time2 = KeQueryPerformanceCounter(NULL);
-                
-                Vcb->stats.read_disk_time += time2.QuadPart - time1.QuadPart;
-            }
-#endif
 
-            for (i = 0; i < needs_reconstruct; i++) {
-                UINT16 reconstruct_stripe = i == 0 ? missing1 : missing2;
-                
-                if (context->stripes[reconstruct_stripe].status != ReadDataStatus_Success) {
-                    ERR("unrecoverable checksum error\n");
+        for (i = 0; i < sectors; i++) {
+            UINT64 off;
+            UINT16 physstripe, parity1, parity2;
+            UINT32 crc32;
+
+            if (context->csum)
+                crc32 = ~calc_crc32c(0xffffffff, buf + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+
+            get_raid0_offset(addr - offset + UInt32x32To64(i, Vcb->superblock.sector_size), ci->stripe_length,
+                             ci->num_stripes - 2, &off, &stripe);
+
+            parity1 = (((addr - offset + UInt32x32To64(i, Vcb->superblock.sector_size)) / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
+            parity2 = (parity1 + 1) % ci->num_stripes;
+
+            physstripe = (parity2 + stripe + 1) % ci->num_stripes;
+
+            if (!devices[physstripe] || !devices[physstripe]->devobj || (context->csum && context->csum[i] != crc32)) {
+                UINT16 k, error_stripe;
+                BOOL recovered = FALSE, failed = FALSE;
+                ULONG num_errors = 0;
+
+                if (devices[physstripe] && devices[physstripe]->devobj)
+                    log_device_error(Vcb, devices[physstripe], BTRFS_DEV_STAT_READ_ERRORS);
+
+                j = (parity2 + 1) % ci->num_stripes;
+
+                for (k = 0; k < ci->num_stripes - 1; k++) {
+                    if (j != physstripe) {
+                        if (devices[j] && devices[j]->devobj) {
+                            Status = sync_read_phys(devices[j]->devobj, cis[j].offset + off, Vcb->superblock.sector_size, sector + (k * Vcb->superblock.sector_size), FALSE);
+                            if (!NT_SUCCESS(Status)) {
+                                ERR("sync_read_phys returned %08x\n", Status);
+                                log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_READ_ERRORS);
+                                num_errors++;
+                                error_stripe = k;
+
+                                if (num_errors > 1) {
+                                    failed = TRUE;
+                                    break;
+                                }
+                            }
+                        } else {
+                            num_errors++;
+                            error_stripe = k;
+
+                            if (num_errors > 1) {
+                                failed = TRUE;
+                                break;
+                            }
+                        }
+                    }
+
+                    j = (j + 1) % ci->num_stripes;
+                }
+
+                if (!failed) {
+                    if (num_errors == 0) {
+                        RtlCopyMemory(sector + (stripe * Vcb->superblock.sector_size), sector + ((ci->num_stripes - 2) * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+
+                        for (j = 0; j < ci->num_stripes - 2; j++) {
+                            if (j != stripe)
+                                do_xor(sector + (stripe * Vcb->superblock.sector_size), sector + (j * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+                        }
+
+                        if (context->csum)
+                            crc32 = ~calc_crc32c(0xffffffff, sector + (stripe * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+
+                        if (!context->csum || crc32 == context->csum[i]) {
+                            RtlCopyMemory(buf + (i * Vcb->superblock.sector_size), sector + (stripe * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+
+                            if (devices[physstripe] && devices[physstripe]->devobj)
+                                ERR("recovering from checksum error at %llx, device %llx\n", addr + UInt32x32To64(i, Vcb->superblock.sector_size),
+                                    devices[physstripe]->devitem.dev_id);
+
+                            recovered = TRUE;
+
+                            if (!Vcb->readonly && devices[physstripe] && devices[physstripe]->devobj && !devices[physstripe]->readonly) { // write good data over bad
+                                Status = write_data_phys(devices[physstripe]->devobj, cis[physstripe].offset + off,
+                                                         sector + (stripe * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+                                if (!NT_SUCCESS(Status)) {
+                                    WARN("write_data_phys returned %08x\n", Status);
+                                    log_device_error(Vcb, devices[physstripe], BTRFS_DEV_STAT_WRITE_ERRORS);
+                                }
+                            }
+                        }
+                    }
+
+                    if (!recovered) {
+                        BOOL read_q = FALSE;
+
+                        if (devices[parity2] && devices[parity2]->devobj) {
+                            Status = sync_read_phys(devices[parity2]->devobj, cis[parity2].offset + off,
+                                                    Vcb->superblock.sector_size, sector + ((ci->num_stripes - 1) * Vcb->superblock.sector_size), FALSE);
+                            if (!NT_SUCCESS(Status)) {
+                                ERR("sync_read_phys returned %08x\n", Status);
+                                log_device_error(Vcb, devices[parity2], BTRFS_DEV_STAT_READ_ERRORS);
+                            } else
+                                read_q = TRUE;
+                        }
+
+                        if (read_q) {
+                            if (num_errors == 1) {
+                                raid6_recover2(sector, ci->num_stripes, Vcb->superblock.sector_size, stripe, error_stripe, sector + (ci->num_stripes * Vcb->superblock.sector_size));
+
+                                if (!devices[physstripe] || !devices[physstripe]->devobj)
+                                    recovered = TRUE;
+                                else {
+                                    crc32 = ~calc_crc32c(0xffffffff, sector + (ci->num_stripes * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+
+                                    if (crc32 == context->csum[i])
+                                        recovered = TRUE;
+                                }
+                            } else {
+                                for (j = 0; j < ci->num_stripes - 1; j++) {
+                                    if (j != stripe) {
+                                        raid6_recover2(sector, ci->num_stripes, Vcb->superblock.sector_size, stripe, j, sector + (ci->num_stripes * Vcb->superblock.sector_size));
+
+                                        crc32 = ~calc_crc32c(0xffffffff, sector + (ci->num_stripes * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+
+                                        if (crc32 == context->csum[i]) {
+                                            recovered = TRUE;
+                                            error_stripe = j;
+                                            break;
+                                        }
+                                    }
+                                }
+                            }
+                        }
+
+                        if (recovered) {
+                            UINT16 error_stripe_phys = (parity2 + error_stripe + 1) % ci->num_stripes;
+
+                            if (devices[physstripe] && devices[physstripe]->devobj)
+                                ERR("recovering from checksum error at %llx, device %llx\n",
+                                    addr + UInt32x32To64(i, Vcb->superblock.sector_size), devices[physstripe]->devitem.dev_id);
+
+                            RtlCopyMemory(buf + (i * Vcb->superblock.sector_size), sector + (ci->num_stripes * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+
+                            if (!Vcb->readonly && devices[physstripe] && devices[physstripe]->devobj && !devices[physstripe]->readonly) { // write good data over bad
+                                Status = write_data_phys(devices[physstripe]->devobj, cis[physstripe].offset + off,
+                                                         sector + (ci->num_stripes * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+                                if (!NT_SUCCESS(Status)) {
+                                    WARN("write_data_phys returned %08x\n", Status);
+                                    log_device_error(Vcb, devices[physstripe], BTRFS_DEV_STAT_WRITE_ERRORS);
+                                }
+                            }
+
+                            if (devices[error_stripe_phys] && devices[error_stripe_phys]->devobj) {
+                                if (error_stripe == ci->num_stripes - 2) {
+                                    ERR("recovering from parity error at %llx, device %llx\n", addr + UInt32x32To64(i, Vcb->superblock.sector_size),
+                                        devices[error_stripe_phys]->devitem.dev_id);
+
+                                    log_device_error(Vcb, devices[error_stripe_phys], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+
+                                    RtlZeroMemory(sector + ((ci->num_stripes - 2) * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+
+                                    for (j = 0; j < ci->num_stripes - 2; j++) {
+                                        if (j == stripe) {
+                                            do_xor(sector + ((ci->num_stripes - 2) * Vcb->superblock.sector_size), sector + (ci->num_stripes * Vcb->superblock.sector_size),
+                                                   Vcb->superblock.sector_size);
+                                        } else {
+                                            do_xor(sector + ((ci->num_stripes - 2) * Vcb->superblock.sector_size), sector + (j * Vcb->superblock.sector_size),
+                                                   Vcb->superblock.sector_size);
+                                        }
+                                    }
+                                } else {
+                                    ERR("recovering from checksum error at %llx, device %llx\n",
+                                        addr + UInt32x32To64(i, Vcb->superblock.sector_size) + ((error_stripe - stripe) * ci->stripe_length),
+                                        devices[error_stripe_phys]->devitem.dev_id);
+
+                                    log_device_error(Vcb, devices[error_stripe_phys], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+
+                                    RtlCopyMemory(sector + (error_stripe * Vcb->superblock.sector_size),
+                                                  sector + ((ci->num_stripes + 1) * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+                                }
+                            }
+
+                            if (!Vcb->readonly && devices[error_stripe_phys] && devices[error_stripe_phys]->devobj && !devices[error_stripe_phys]->readonly) { // write good data over bad
+                                Status = write_data_phys(devices[error_stripe_phys]->devobj, cis[error_stripe_phys].offset + off,
+                                                         sector + (error_stripe * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+                                if (!NT_SUCCESS(Status)) {
+                                    WARN("write_data_phys returned %08x\n", Status);
+                                    log_device_error(Vcb, devices[error_stripe_phys], BTRFS_DEV_STAT_WRITE_ERRORS);
+                                }
+                            }
+                        }
+                    }
+                }
+
+                if (!recovered) {
+                    ERR("unrecoverable checksum error at %llx\n", addr + UInt32x32To64(i, Vcb->superblock.sector_size));
+                    ExFreePool(sector);
                     return STATUS_CRC_ERROR;
                 }
             }
         }
-        
-        off = origoff;
-        
-        if (context->tree) {
-            pos = 0;
-            stripeoff = 0;
-            if (!raid6_decode_with_checksum_metadata(addr, off, skip, context, ci, &stripeoff, buf, &pos, length, firststripesize, Vcb->superblock.node_size)) {
-                ERR("unrecoverable metadata checksum error\n");
-                return STATUS_CRC_ERROR;
-            }
-        } else {
-            pos = 0;
-            stripeoff = 0;
-            if (!raid6_decode_with_checksum(off, skip, context, ci, &stripeoff, buf, &pos, length, firststripesize, context->csum, Vcb->superblock.sector_size))
-                return STATUS_CRC_ERROR;
-            
-            while (pos < length) {
-                off += (ci->num_stripes - 1) * ci->stripe_length;
-                if (!raid6_decode_with_checksum(off, 0, context, ci, &stripeoff, buf, &pos, length, 0, context->csum, Vcb->superblock.sector_size))
-                    return STATUS_CRC_ERROR;
-            }
-        }
+
+        ExFreePool(sector);
     }
-    
-    // write good data over bad
-    
-    if (!Vcb->readonly) {
-        CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&ci[1];
-        
-        for (i = 0; i < ci->num_stripes; i++) {
-            if (context->stripes[i].rewrite && devices[i] && !devices[i]->readonly) {
-                Status = write_data_phys(devices[i]->devobj, cis[i].offset + stripestart[i], context->stripes[i].buf, stripeend[i] - stripestart[i]);
-                
-                if (!NT_SUCCESS(Status))
-                    WARN("write_data_phys returned %08x\n", Status);
-            }
-        }
-    }
-    
+
     return STATUS_SUCCESS;
 }
 
-NTSTATUS STDCALL read_data(device_extension* Vcb, UINT64 addr, UINT32 length, UINT32* csum, BOOL is_tree, UINT8* buf, chunk* c, chunk** pc,
-                           PIRP Irp, BOOL check_nocsum_parity) {
+NTSTATUS read_data(_In_ device_extension* Vcb, _In_ UINT64 addr, _In_ UINT32 length, _In_reads_bytes_opt_(length*sizeof(UINT32)/Vcb->superblock.sector_size) UINT32* csum,
+                   _In_ BOOL is_tree, _Out_writes_bytes_(length) UINT8* buf, _In_opt_ chunk* c, _Out_opt_ chunk** pc, _In_opt_ PIRP Irp, _In_ UINT64 generation, _In_ BOOL file_read,
+                   _In_ ULONG priority) {
     CHUNK_ITEM* ci;
     CHUNK_ITEM_STRIPE* cis;
-    read_data_context* context;
-    UINT64 i, type, offset;
+    read_data_context context;
+    UINT64 type, offset, total_reading = 0;
     NTSTATUS Status;
-    device** devices;
-    UINT64 *stripestart = NULL, *stripeend = NULL;
-    UINT32 firststripesize;
-    UINT16 startoffstripe, allowed_missing, missing_devices = 0;
+    device** devices = NULL;
+    UINT16 i, startoffstripe, allowed_missing, missing_devices = 0;
+    UINT8* dummypage = NULL;
+    PMDL dummy_mdl = NULL;
+    BOOL need_to_wait;
+    UINT64 lockaddr, locklen;
 #ifdef DEBUG_STATS
     LARGE_INTEGER time1, time2;
 #endif
-    
+
     if (Vcb->log_to_phys_loaded) {
         if (!c) {
             c = get_chunk_from_address(Vcb, addr);
-            
+
             if (!c) {
                 ERR("get_chunk_from_address failed\n");
                 return STATUS_INTERNAL_ERROR;
             }
         }
-        
+
         ci = c->chunk_item;
         offset = c->offset;
         devices = c->devices;
-           
+
         if (pc)
             *pc = c;
     } else {
         LIST_ENTRY* le = Vcb->sys_chunks.Flink;
-        
+
         ci = NULL;
-        
+
+        c = NULL;
         while (le != &Vcb->sys_chunks) {
             sys_chunk* sc = CONTAINING_RECORD(le, sys_chunk, list_entry);
-            
+
             if (sc->key.obj_id == 0x100 && sc->key.obj_type == TYPE_CHUNK_ITEM && sc->key.offset <= addr) {
                 CHUNK_ITEM* chunk_item = sc->data;
-                
+
                 if ((addr - sc->key.offset) < chunk_item->size && chunk_item->num_stripes > 0) {
                     ci = chunk_item;
                     offset = sc->key.offset;
                     cis = (CHUNK_ITEM_STRIPE*)&chunk_item[1];
-                    
+
                     devices = ExAllocatePoolWithTag(PagedPool, sizeof(device*) * ci->num_stripes, ALLOC_TAG);
                     if (!devices) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     for (i = 0; i < ci->num_stripes; i++) {
                         devices[i] = find_device_from_uuid(Vcb, &cis[i].dev_uuid);
                     }
-                    
+
                     break;
                 }
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (!ci) {
             ERR("could not find chunk for %llx in bootstrap\n", addr);
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         if (pc)
             *pc = NULL;
     }
-    
+
     if (ci->type & BLOCK_FLAG_DUPLICATE) {
         type = BLOCK_FLAG_DUPLICATE;
-        allowed_missing = 0;
+        allowed_missing = ci->num_stripes - 1;
     } else if (ci->type & BLOCK_FLAG_RAID0) {
         type = BLOCK_FLAG_RAID0;
         allowed_missing = 0;
